## kcov 36+dfsg

=== src/CMakeLists.txt ===
find_package (Threads)
find_package (Bfd)

include(TargetArch)
target_architecture(CMAKE_TARGET_ARCHITECTURES)
message(STATUS "Target architectures: ${CMAKE_TARGET_ARCHITECTURES}")

find_package (ZLIB REQUIRED)
find_package (CURL)

if (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
SET (DL_LIBRARY "")
else (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
find_library (DL_LIBRARY NAMES dl)
if (DL_LIBRARY)
    message (STATUS "Found DL: ${DL_LIBRARY}")
else (DL_LIBRARY)
    message (FATAL_ERROR "Could NOT find DL")
endif (DL_LIBRARY)
endif (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)

if (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
find_library (INTL_LIBRARY NAMES intl)
if (INTL_LIBRARY)
    message (STATUS "Found INTL: ${INTL_LIBRARY}")
else (INTL_LIBRARY)
    message (FATAL_ERROR "Could NOT find INTL")
endif (INTL_LIBRARY)
else (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
SET (INTL_LIBRARY "")
endif (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)

find_library (M_LIBRARY NAMES m)
if (M_LIBRARY)
    message (STATUS "Found M: ${M_LIBRARY}")
else (M_LIBRARY)
    message (FATAL_ERROR "Could NOT find M")
endif (M_LIBRARY)

set (KCOV kcov)


# See http://eatmyrandom.blogspot.se/2010/06/automate-version-numbering-using-git.html
if (EXISTS "${CMAKE_SOURCE_DIR}/.git")
    find_program (GIT_EXECUTABLE NAMES git)
    if (GIT_EXECUTABLE)
        message (STATUS "Found Git: ${GIT_EXECUTABLE}")
    else (GIT_EXECUTABLE)
        message (FATAL_ERROR "Could NOT find Git")
    endif (GIT_EXECUTABLE)

    execute_process (COMMAND "${GIT_EXECUTABLE}"
            "--git-dir=${CMAKE_SOURCE_DIR}/.git"
            describe
            --abbrev=4
            HEAD
        OUTPUT_VARIABLE POD_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
else (EXISTS "${CMAKE_SOURCE_DIR}/.git")
    execute_process (COMMAND head
            -n 1
            "${CMAKE_SOURCE_DIR}/ChangeLog"
        COMMAND cut -d \( -f 2
        COMMAND cut -d \) -f 1
        OUTPUT_VARIABLE POD_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
endif (EXISTS "${CMAKE_SOURCE_DIR}/.git")

add_custom_command(
    OUTPUT version.c
    COMMAND "${CMAKE_COMMAND}"
           -E echo
           "const char *kcov_version = \\\"${POD_VERSION}\\\"\;"
        > version.c
)

set (SOLIB kcov_sowrapper)

set (${SOLIB}_SRCS
	solib-parser/phdr_data.c
	solib-parser/lib.c
	)

set (DISASSEMBLER_SRCS
	parsers/dummy-disassembler.cc
)

set (HAS_LIBBFD "0")

if (CMAKE_TARGET_ARCHITECTURES STREQUAL "i386" OR CMAKE_TARGET_ARCHITECTURES STREQUAL "x86_64")
	if (LIBBFD_FOUND)
		set (HAS_LIBBFD "1")
		set (DISASSEMBLER_SRCS
			parsers/bfd-disassembler.cc
		)
		set (DISASSEMBLER_LIBRARIES
			${LIBBFD_OPCODES_LIBRARY}
			${LIBBFD_BFD_LIBRARY}
			${LIBBFD_IBERTY_LIBRARY}
		)
	endif (LIBBFD_FOUND)
endif (CMAKE_TARGET_ARCHITECTURES STREQUAL "i386" OR CMAKE_TARGET_ARCHITECTURES STREQUAL "x86_64")

set (coveralls_SRCS writers/dummy-coveralls-writer.cc)

if (CURL_FOUND)
	set (coveralls_SRCS writers/coveralls-writer.cc)
endif (CURL_FOUND)

if (KCOV_STATIC_BUILD STREQUAL "1")
	message(STATUS "Building a static binary (no coveralls support)")

	set (CURL_LIBRARIES "")
	# Coveralls doesn't work in a static setting
	set (coveralls_SRCS writers/dummy-coveralls-writer.cc)
	set (CMAKE_EXE_LINKER_FLAGS "-static")
endif (KCOV_STATIC_BUILD STREQUAL "1")

set (ELF_SRCS
	dummy-solib-handler.cc
)
set (MACHO_SRCS
)
set (SOLIB_generated )

# Linux-specific sources
if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
	find_package (LibElf)
	find_package (Elfutils)
	set (ELF_SRCS
		engines/clang-coverage-engine.cc
		engines/ptrace.cc
		engines/ptrace_linux.cc
		engines/kernel-engine.cc
		parsers/elf.cc
		parsers/elf-parser.cc
		parsers/dwarf.cc
		solib-handler.cc
		solib-parser/phdr_data.c
	)
	set (SOLIB_generated library.cc)
	add_library (${SOLIB} SHARED ${${SOLIB}_SRCS})
	set_target_properties(${SOLIB} PROPERTIES SUFFIX ".so")
	target_link_libraries(${SOLIB} dl)
elseif (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
	find_package (LibElf)
	find_package (Elfutils)
	set (ELF_SRCS
		engines/clang-coverage-engine.cc
		engines/ptrace.cc
		engines/ptrace_freebsd.cc
		parsers/elf.cc
		parsers/elf-parser.cc
		parsers/dwarf.cc
		solib-handler.cc
		solib-parser/phdr_data.c
	)
	set (SOLIB_generated library.cc)
	add_library (${SOLIB} SHARED ${${SOLIB}_SRCS})
	set_target_properties(${SOLIB} PROPERTIES SUFFIX ".so")
else (CMAKE_SYSTEM_NAME STREQUAL "Linux")
	find_library(LLDB_LIBRARY
      NAMES
	    LLDB
	  PATHS
        "/usr/lib"
        "/usr/lib64"
        "/usr/local/lib"
        "/usr/local/lib64"
        "/opt/local/lib"
        "/opt/usr/lib64"
		"/Library/Developer/CommandLineTools/Library/PrivateFrameworks"
		"/Applications/Xcode.app/Contents/SharedFrameworks"
		ENV LIBRARY_PATH
		ENV LD_LIBRARY_PATH
	)
	mark_as_advanced(LLDB_LIBRARY)

	# Not really true, but anyway
	set(LIBELF_FOUND 1)

	set (MACHO_SRCS
		engines/lldb-engine.cc
	)
endif (CMAKE_SYSTEM_NAME STREQUAL "Linux")

set (${KCOV}_SRCS
    capabilities.cc
    collector.cc
    configuration.cc
    engine-factory.cc
    engines/bash-engine.cc
    engines/system-mode-engine.cc
    engines/system-mode-file-format.cc
    engines/python-engine.cc
    filter.cc
    gcov.cc
    main.cc
    merge-file-parser.cc
    output-handler.cc
    ${DISASSEMBLER_SRCS}
    parser-manager.cc
    reporter.cc
    source-file-cache.cc
    utils.cc
    writers/cobertura-writer.cc
    writers/json-writer.cc
    ${coveralls_SRCS}
    writers/html-writer.cc
    writers/sonarqube-xml-writer.cc
    writers/writer-base.cc
    ${ELF_SRCS}
    ${MACHO_SRCS}
    include/capabilities.hh
    include/gcov.hh
    include/reporter.hh
    include/collector.hh
    include/generated-data-base.hh
    include/solib-handler.hh
    include/configuration.hh
    include/lineid.hh
    include/swap-endian.hh
    include/engine.hh
    include/manager.hh
    include/utils.hh
    include/file-parser.hh
    include/output-handler.hh
    include/writer.hh
    include/filter.hh
    include/phdr_data.h
    system-mode/file-data.cc
    )

set (KCOV_SYSTEM_MODE_SRCS
    configuration.cc
	dummy-solib-handler.cc
    engine-factory.cc
    engines/system-mode-file-format.cc
    engines/ptrace.cc
    engines/ptrace_linux.cc
    filter.cc
    gcov.cc
    include/capabilities.hh
    include/collector.hh
    include/configuration.hh
    include/engine.hh
    include/file-parser.hh
    include/filter.hh
    include/gcov.hh
    include/generated-data-base.hh
    include/lineid.hh
    include/manager.hh
    include/output-handler.hh
    include/phdr_data.h
    include/reporter.hh
    include/solib-handler.hh
    include/swap-endian.hh
    include/utils.hh
    include/writer.hh
    main-system-daemon.cc
    parser-manager.cc
	system-mode/file-data.cc
	system-mode/registration.cc
    utils.cc
)

set (KCOV_LIBRARY_PREFIX "/tmp")

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -g -Wall -D_GLIBCXX_USE_NANOSLEEP -DKCOV_LIBRARY_PREFIX=${KCOV_LIBRARY_PREFIX} -DKCOV_HAS_LIBBFD=${HAS_LIBBFD}")

include_directories(
	include/
	../external/lldb/include/
	${ZLIB_INCLUDE_DIR}
	)

if (LIBDW_FOUND)
    include_directories(${LIBDW_INCLUDE_DIRS})
endif (LIBDW_FOUND)

if (LIBELF_FOUND)
    include_directories(${LIBELF_INCLUDE_DIRS})
endif (LIBELF_FOUND)

if (CURL_FOUND)
    include_directories(${CURL_INCLUDE_DIRS})
endif (CURL_FOUND)

add_library (bash_execve_redirector SHARED engines/bash-execve-redirector.c)
set_target_properties(bash_execve_redirector PROPERTIES SUFFIX ".so")
target_link_libraries(bash_execve_redirector ${DL_LIBRARY})

add_library (kcov_system_lib SHARED engines/system-mode-binary-lib.cc utils.cc system-mode/registration.cc)
set_target_properties(kcov_system_lib PROPERTIES SUFFIX ".so")
target_link_libraries(kcov_system_lib
    "${DL_LIBRARY}"
)


add_custom_command(
    OUTPUT library.cc
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py"
            lib${SOLIB}.so
            __library
        > library.cc
    DEPENDS
        ${SOLIB}
        "${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py"
)

add_custom_command(
    OUTPUT bash-redirector-library.cc
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py"
            $<TARGET_FILE:bash_execve_redirector>
            bash_redirector_library
        > bash-redirector-library.cc
    DEPENDS
        bash_execve_redirector
        "${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py"
)

add_custom_command(
    OUTPUT kcov-system-library.cc
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py"
            $<TARGET_FILE:kcov_system_lib>
            kcov_system_library
        > kcov-system-library.cc
    DEPENDS
        kcov_system_lib
       "${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py"
)

add_custom_command(
    OUTPUT python-helper.cc
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py"
            "${CMAKE_CURRENT_SOURCE_DIR}/engines/python-helper.py"
            python_helper
        > python-helper.cc
    DEPENDS
        "${CMAKE_CURRENT_SOURCE_DIR}/engines/python-helper.py"
        "${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py"
)

add_custom_command(
    OUTPUT bash-helper.cc
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py"
            "${CMAKE_CURRENT_SOURCE_DIR}/engines/bash-helper.sh"
            bash_helper
            "${CMAKE_CURRENT_SOURCE_DIR}/engines/bash-helper-debug-trap.sh"
            bash_helper_debug_trap
        > bash-helper.cc
    DEPENDS
        "${CMAKE_CURRENT_SOURCE_DIR}/engines/bash-helper.sh"
        "${CMAKE_CURRENT_SOURCE_DIR}/engines/bash-helper-debug-trap.sh"
        "${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py"
)

add_custom_command(
    OUTPUT html-data-files.cc
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py"
            "${CMAKE_CURRENT_SOURCE_DIR}/../data/bcov.css" css_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../data/amber.png" icon_amber
            "${CMAKE_CURRENT_SOURCE_DIR}/../data/glass.png" icon_glass
            "${CMAKE_CURRENT_SOURCE_DIR}/../data/source-file.html" source_file_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../data/index.html" index_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../data/js/handlebars.js" handlebars_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../data/js/kcov.js" kcov_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../data/js/jquery.min.js" jquery_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../data/js/jquery.tablesorter.min.js" tablesorter_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../data/js/jquery.tablesorter.widgets.min.js" tablesorter_widgets_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../data/tablesorter-theme.css" tablesorter_theme_text
        > html-data-files.cc
    DEPENDS
        "${CMAKE_CURRENT_SOURCE_DIR}/../data/bcov.css"
        "${CMAKE_CURRENT_SOURCE_DIR}/../data/amber.png"
        "${CMAKE_CURRENT_SOURCE_DIR}/../data/glass.png"
        "${CMAKE_CURRENT_SOURCE_DIR}/../data/source-file.html"
        "${CMAKE_CURRENT_SOURCE_DIR}/../data/index.html"
        "${CMAKE_CURRENT_SOURCE_DIR}/../data/js/handlebars.js"
        "${CMAKE_CURRENT_SOURCE_DIR}/../data/js/kcov.js"
        "${CMAKE_CURRENT_SOURCE_DIR}/../data/js/jquery.min.js"
        "${CMAKE_CURRENT_SOURCE_DIR}/../data/js/jquery.tablesorter.min.js"
        "${CMAKE_CURRENT_SOURCE_DIR}/../data/js/jquery.tablesorter.widgets.min.js"
        "${CMAKE_CURRENT_SOURCE_DIR}/../data/tablesorter-theme.css"
        "${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py"
)

# Reference: http://www.cmake.org/Wiki/CMake_RPATH_handling
if (SPECIFY_RPATH)
	set (CMAKE_SKIP_BUILD_RPATH  FALSE)
	set (CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
	set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
	# the RPATH to be used when installing, but only if it's not a system directory
	list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" IS_SYSTEM_DIR)
	if (IS_SYSTEM_DIR STREQUAL "-1")
	    set (CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
	endif (IS_SYSTEM_DIR STREQUAL "-1")
endif (SPECIFY_RPATH)

if (LIBELF_FOUND)

=== tests/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.4)
project (kcov-tests)

enable_language(ASM)

if (POLICY CMP0042)
    # MACOSX_RPATH is enabled by default.
    cmake_policy (SET CMP0042 NEW)
endif (POLICY CMP0042)

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    set (CMAKE_BUILD_TYPE Debug CACHE STRING
        "Choose the type of build, options are None Debug Release RelWithDebInfo MinSizeRel"
        FORCE
    )
    set_property (CACHE CMAKE_BUILD_TYPE PROPERTY
        STRINGS None Debug Release RelWithDebInfo MinSizeRel
    )
endif (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)

set (CMAKE_THREAD_PREFER_PTHREAD ON)
find_package (Threads REQUIRED)

find_package (ZLIB REQUIRED)

if (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
SET (DL_LIBRARY "")
else (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
find_library (DL_LIBRARY NAMES dl)
if (DL_LIBRARY)
    message (STATUS "Found DL: ${DL_LIBRARY}")
else (DL_LIBRARY)
    message (FATAL_ERROR "Could NOT find DL")
endif (DL_LIBRARY)
endif (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)

find_library (M_LIBRARY NAMES m)
if (M_LIBRARY)
    message (STATUS "Found M: ${M_LIBRARY}")
else (M_LIBRARY)
    message (FATAL_ERROR "Could NOT find M")
endif (M_LIBRARY)

include_directories(
    "${CMAKE_CURRENT_BINARY_DIR}"
    ../src/include
)
set (CMAKE_CXX_FLAGS "-std=c++0x -Wall -D_GLIBCXX_USE_NANOSLEEP -DKCOV_LIBRARY_PREFIX=${KCOV_LIBRARY_PREFIX}")

add_custom_command (OUTPUT multi-fork-generated.c
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/multi-fork/generate-functions.py"
            "${CMAKE_CURRENT_SOURCE_DIR}/multi-fork/code-template.c"
            1024
        > "${CMAKE_CURRENT_BINARY_DIR}/multi-fork-generated.c"
    DEPENDS
        "${CMAKE_CURRENT_SOURCE_DIR}/multi-fork/generate-functions.py"
)

add_custom_target(multi-fork-generated ALL
    DEPENDS multi-fork-generated.c
)
set_property(SOURCE multi-fork/test-multi-fork.c APPEND PROPERTY
    OBJECT_DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/multi-fork-generated.c"
)


set (main_tests_SRCS
    main.cc
    subdir/file.c
    subdir2/file2.c
)

set (argv_dependent_SRCS
    argv-dependent.c
)

set (fork_SRCS
    fork/fork.c
)

set (fork_no_wait_SRCS
    fork/fork-no-wait.c
)

set (signals_SRCS
    signals/test-signals.c
)

set (multi_fork_SRCS
    multi-fork/test-multi-fork.c
)

set (recursive-ptrace_SRCS
    recursive-ptrace/main.cc
)

set (shared_library_test_SRCS
    shared-library/main.c
)

set (test_popen_SRCS
    popen/test-popen.c
)

set (global_constructors_SRCS
    global-constructors/test-global-ctors.cc
)

set (daemon_SRCS
    daemon/test-daemon.cc
)

add_library(shared_library SHARED
    shared-library/big-symbol.S
    shared-library/solib.c
)

add_executable(main-tests ${main_tests_SRCS})
add_executable(fork ${fork_SRCS})
add_executable(fork_no_wait ${fork_no_wait_SRCS})
add_executable(vfork fork/vfork.c)
add_executable(signals ${signals_SRCS})

add_executable(multi_fork ${multi_fork_SRCS})
target_link_libraries(multi_fork "${M_LIBRARY}")

add_executable(shared_library_test ${shared_library_test_SRCS})
target_link_libraries(shared_library_test shared_library)

add_executable(argv_dependent ${argv_dependent_SRCS})
add_executable(test_popen ${test_popen_SRCS})

add_executable(global-constructors ${global_constructors_SRCS})
target_link_libraries(global-constructors shared_library)

add_executable(test_daemon ${daemon_SRCS})
add_executable(multi_1 merge-tests/file.c merge-tests/main_1.c)
add_executable(multi_2 merge-tests/file.c merge-tests/main_2.c)

add_executable(setpgid-kill setpgid-kill/setpgid-kill-main.cc ../src/utils.cc)
target_link_libraries(setpgid-kill ${ZLIB_LIBRARIES})

add_executable(issue31 daemon/test-issue31.cc)
target_link_libraries(issue31 ${CMAKE_THREAD_LIBS_INIT})

add_executable(dlopen dlopen/dlopen.cc dlopen/dlopen-main.cc)
target_link_libraries(dlopen "${DL_LIBRARY}")

add_executable(s short-file.c)
add_executable(fork+exec fork/fork+exec.c)

add_executable(thread-test threads/thread-main.c)
target_link_libraries(thread-test ${CMAKE_THREAD_LIBS_INIT})

#if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
#    add_executable(sanitizer-coverage sanitizer-coverage.c)
#    set_target_properties(sanitizer-coverage PROPERTIES COMPILE_FLAGS "-g -fsanitize=address -fsanitize-coverage=bb")
#    set_target_properties(sanitizer-coverage PROPERTIES LINK_FLAGS "-fsanitize=address -fsanitize-coverage=bb")
#endif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")

add_executable (pie pie.c)
if (CMAKE_VERSION VERSION_LESS "2.8.9")
    set_target_properties (pie PROPERTIES COMPILE_FLAGS -fPIE)
else (CMAKE_VERSION VERSION_LESS "2.8.9")
    set_target_properties (pie PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif (CMAKE_VERSION VERSION_LESS "2.8.9")

add_executable (pie-test argv-dependent.c)
if (CMAKE_VERSION VERSION_LESS "2.8.9")
    set_target_properties (pie-test PROPERTIES COMPILE_FLAGS -fPIE)
else (CMAKE_VERSION VERSION_LESS "2.8.9")
    set_target_properties (pie-test PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif (CMAKE_VERSION VERSION_LESS "2.8.9")

if (NOT(CMAKE_SYSTEM_NAME STREQUAL "Darwin"))
    add_executable(recursive-ptrace ${recursive-ptrace_SRCS})
    add_custom_target (illegal-insn ALL
        COMMAND "${CMAKE_C_COMPILER}"
            -nostdlib
            "${CMAKE_CURRENT_SOURCE_DIR}/assembly/illegal-insn.S"
            -o "${CMAKE_CURRENT_BINARY_DIR}/illegal-insn"
    )

    add_custom_target (fork-32 ALL
        COMMAND "${CMAKE_C_COMPILER}" -g -m32
            "${CMAKE_CURRENT_SOURCE_DIR}/fork/fork.c"
            -o "${CMAKE_CURRENT_BINARY_DIR}/fork-32"
    )
endif (NOT(CMAKE_SYSTEM_NAME STREQUAL "Darwin"))

add_custom_target(tests-stripped ALL
    COMMAND "${CMAKE_STRIP}" -o tests-stripped main-tests
    DEPENDS main-tests)

=== tools/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.4)
project (kcov-tools)
list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake")

if (POLICY CMP0042)
    # MACOSX_RPATH is enabled by default.
    cmake_policy (SET CMP0042 NEW)
endif (POLICY CMP0042)

find_package (LibElf REQUIRED)
find_package (Elfutils REQUIRED)
find_package (PkgConfig REQUIRED)
find_package (Threads)
find_package (ZLIB REQUIRED)

find_library (DL_LIBRARY NAMES dl)
if (DL_LIBRARY)
    message (STATUS "Found DL: ${DL_LIBRARY}")
else (DL_LIBRARY)
    message (FATAL_ERROR "Could NOT find DL")
endif (DL_LIBRARY)

find_library (M_LIBRARY NAMES m)
if (M_LIBRARY)
    message (STATUS "Found M: ${M_LIBRARY}")
else (M_LIBRARY)
    message (FATAL_ERROR "Could NOT find M")
endif (M_LIBRARY)

# ====================================
# project name and version
# ====================================
set (LINE2ADDR line2addr)

set (${LINE2ADDR}_SRCS
    ../src/capabilities.cc
    ../src/configuration.cc
    ../src/filter.cc
    ../src/gcov.cc
    ../src/parsers/dwarf.cc
    ../src/parsers/elf-parser.cc
    ../src/parsers/elf.cc
    ../src/parsers/dummy-disassembler.cc
    ../src/parser-manager.cc
    ../src/utils.cc
    line2addr.cc
)


set (CMAKE_CXX_FLAGS "-std=c++0x -g -Wall -D_GLIBCXX_USE_NANOSLEEP -DKCOV_LIBRARY_PREFIX=${KCOV_LIBRARY_PREFIX}")

include_directories(
    ../src/include/
    ${LIBELF_INCLUDE_DIRS}
    ${LIBDW_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
)

# Reference: http://www.cmake.org/Wiki/CMake_RPATH_handling
if (SPECIFY_RPATH)
    set (CMAKE_SKIP_BUILD_RPATH  FALSE)
    set (CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
    # the RPATH to be used when installing, but only if it's not a system directory
    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" IS_SYSTEM_DIR)
    if (IS_SYSTEM_DIR STREQUAL "-1")
        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    endif (IS_SYSTEM_DIR STREQUAL "-1")
endif (SPECIFY_RPATH)

add_executable (${LINE2ADDR} ${${LINE2ADDR}_SRCS})

target_link_libraries(${LINE2ADDR}
    "${DL_LIBRARY}"
    ${LIBDW_LIBRARIES}
    ${LIBELF_LIBRARIES}
    "${M_LIBRARY}"
    stdc++
    ${CMAKE_THREAD_LIBS_INIT}
    ${ZLIB_LIBRARIES})

=== travis/Makefile ===
#!/usr/bin/make

chroot=/tmp/32-bit-chroot
kcov_deps=libdw-dev libelf-dev elfutils libcurl4-openssl-dev python python3 cmake binutils-dev git

.PHONY: prepare_environment

build_reference:
	mkdir -p reference/src reference/build
	cd reference/ && git clone https://github.com/SimonKagstrom/kcov.git
	cd reference/kcov && git checkout v23
	cd reference/build && cmake ../kcov
	make -C reference/build/
	cp reference/build/src/kcov /tmp/kcov-reference

build-osx-xcode:
	mkdir -p build-xcode
	cd build-xcode && cmake -G Xcode ..
	cd build-xcode && xcodebuild

build-osx: build-osx-xcode
	mkdir -p build build-tests
	cd build && cmake ..
	make -C build
	cd build-tests && cmake ../tests
	make -C build-tests

build:
	mkdir -p build build-tests build-tools
	cd build && CXXFLAGS=-Werror cmake ..
	make -C build
	cd build-tools && cmake ../tools
	make -C build-tools
	sudo make -C build install
	cd build-tests && cmake ../tests
	make -C build-tests

build_gcc: build run_unit_tests build_reference patchelf-i386-chroot
	sudo rm -rf ${chroot}/tmp/kcov/build ${chroot}/tmp/kcov/build-tests
	sudo mkdir -p ${chroot}/tmp/kcov/build ${chroot}/tmp/kcov/build-tests ${chroot}/tmp/kcov/build-tools
	sudo i386 chroot ${chroot} sh -c "cd /tmp/kcov/build && cmake .."
	sudo i386 chroot ${chroot} sh -c "make -C /tmp/kcov/build"
	sudo i386 chroot ${chroot} sh -c "make -C /tmp/kcov/build install"
	sudo i386 chroot ${chroot} sh -c "cd /tmp/kcov/build-tools && cmake ../tools"
	sudo i386 chroot ${chroot} sh -c "make -C /tmp/kcov/build-tools"
	sudo i386 chroot ${chroot} sh -c "cd /tmp/kcov/build-tests && cmake ../tests"
	sudo i386 chroot ${chroot} sh -c "make -C /tmp/kcov/build-tests"
	sudo i386 chroot ${chroot} sh -c "apt-get -y remove binutils-dev"
	sudo i386 chroot ${chroot} sh -c "mkdir -p /tmp/kcov/build-no-binutils && cd /tmp/kcov/build-no-binutils && cmake .."
	sudo i386 chroot ${chroot} sh -c "make -C /tmp/kcov/build-no-binutils"
	sudo i386 chroot ${chroot} sh -c "mkdir -p /tmp/kcov/build-static && cd /tmp/kcov/build-static && cmake -DKCOV_STATIC_BUILD=1 .."
	sudo i386 chroot ${chroot} sh -c "make -C /tmp/kcov/build-static"

build_clang_linux:
	mkdir -p build build-tests build-tools
	cd build && CC=clang-3.9 CXX=clang++-3.9 CXXFLAGS=-Werror cmake ..
	make -C build
	cd build-tools && cmake ../tools
	make -C build-tools
	sudo make -C build install
	cd build-tests && CC=clang-3.9 CXX=clang++-3.9 cmake ../tests
	CC=clang-3.9 CXX=clang++-3.9 make -C build-tests

build_clang:
	mkdir -p build build-tests build-tools
	cd build && CC=clang-3.9 CXX=clang++-3.9 CXXFLAGS=-Werror cmake ..
	make -C build
	cd build-tools && cmake ../tools
	make -C build-tools
	sudo make -C build install
	cd build-tests && CC=clang-3.9 CXX=clang++-3.9 cmake ../tests
	CC=clang-3.9 CXX=clang++-3.9 make -C build-tests

run-performance: build_gcc
	travis/perf-test.sh build/src/kcov . build >/dev/null
	/usr/bin/time -f "%e" travis/perf-test.sh build/src/kcov . build >/dev/null
	rm -rf /tmp/kcov-perf
	travis/perf-test.sh /tmp/kcov-reference . build >/dev/null
	/usr/bin/time -f "%e" travis/perf-test.sh /tmp/kcov-reference . build >/dev/null

run-tests-linux-gcc: run-performance
	tests/tools/run-tests build/src/kcov /tmp/ build-tests/ `pwd` -v
	sudo i386 chroot ${chroot} sh -c "mkdir -p /tmp/output"
	sudo i386 chroot ${chroot} sh -c "PATH=/bin:/usr/bin:/sbin:/usr/sbin /tmp/kcov/tests/tools/run-tests /tmp/kcov/build/src/kcov /tmp/output /tmp/kcov/build-tests/ /tmp/kcov -v"
	build/src/kcov --coveralls-id=$(TRAVIS_JOB_ID) --include-pattern=kcov --exclude-pattern=helper.cc,library.cc,html-data-files.cc /tmp/kcov-kcov build/src/kcov || true
	wget https://codecov.io/bash || true
	bash bash -s /tmp/kcov-kcov || true

run-tests-linux-clang: build_clang_linux
	tests/tools/run-tests build/src/kcov /tmp/ build-tests/ `pwd` -v

trompeloeil:
	git submodule update --recursive --remote

patchelf:
	wget https://github.com/NixOS/patchelf/archive/0.9.tar.gz
	tar -xf 0.9.tar.gz
	cd patchelf-0.9 && ./bootstrap.sh && ./configure && make && sudo make install

patchelf-i386-chroot: patchelf
	wget https://github.com/NixOS/patchelf/archive/0.9.tar.gz
	sudo cp 0.9.tar.gz ${chroot}
	sudo i386 chroot ${chroot} sh -c "tar -xf 0.9.tar.gz"
	sudo i386 chroot ${chroot} sh -c "cd patchelf-0.9 && ./bootstrap.sh && ./configure && make && make install"

build_unit_tests: trompeloeil
	mkdir -p build-ut
	cd build-ut && CXX=g++-6 CC=gcc-6 cmake ../tests/unit-tests/
	CXX=g++-6 CC=gcc-6 make -C build-ut

run_unit_tests: build build_unit_tests
	cd build-ut && ./ut

run-tests-osx-gcc: build-osx
	tests/tools/run-tests build/src/kcov /tmp/ build-tests/ `pwd` -v

run-tests-osx-clang: build-osx
	tests/tools/run-tests build/src/kcov /tmp/ build-tests/ `pwd` -v


run-tests: run-tests-${TRAVIS_OS_NAME}-${CC}


prepare_osx_clang:

prepare_osx_gcc:

prepare_osx:
	brew update
	brew install zlib
	brew upgrade python
	brew install bash

prepare_linux: patchelf
	sudo sh -c "echo 0 > /proc/sys/kernel/yama/ptrace_scope"
	sudo add-apt-repository ppa:jonlar/crpcut -y
	sudo apt-get update -q
	sudo apt-get install -y --allow-unauthenticated ${kcov_deps} gcc-multilib debootstrap git time curl crpcut crpcut-dev

prepare_linux_gcc:
	sudo add-apt-repository ppa:ubuntu-toolchain-r/test -y
	sudo apt-get update -q
	sudo apt-get install g++-6

	sudo i386 debootstrap --arch=i386 --components=main,universe  precise $(chroot)
	sudo i386 chroot "${chroot}" apt-get update
	sudo i386 chroot "${chroot}" apt-get install -y build-essential autoconf
	sudo i386 chroot "${chroot}" apt-get install -y --allow-unauthenticated ${kcov_deps}
	sudo cp -r "$(shell pwd)" "${chroot}/tmp/"
	sudo i386 chroot "${chroot}" sh -c "mount -t proc procfs /proc"
	sudo i386 chroot "${chroot}" sh -c "mount -t tmpfs none /dev/shm"


prepare_linux_clang:
	sudo apt-add-repository -y 'deb http://llvm.org/apt/trusty llvm-toolchain-trusty-3.9 main'
	sudo apt-get update --force-yes -qq
	sudo apt-get install -qq --force-yes -y clang-3.9 libboost-all-dev binutils-dev

prepare_environment: prepare_${TRAVIS_OS_NAME} prepare_${TRAVIS_OS_NAME}_${CC}

=== debian/changelog ===
kcov (36+dfsg-1build5) eoan; urgency=medium

  * No-change upload for binutils 2.33.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 08 Oct 2019 13:20:57 +0200

kcov (36+dfsg-1build4) eoan; urgency=medium

  * No-change upload for binutils 2.32.90.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 29 Sep 2019 09:48:34 +0200

kcov (36+dfsg-1build3) eoan; urgency=medium

  * No-change upload for binutils 2.32.90.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 19 Sep 2019 09:22:52 +0200

kcov (36+dfsg-1build2) eoan; urgency=medium

  * No-change upload for binutils 2.32.51.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Sep 2019 10:14:32 +0000

kcov (36+dfsg-1build1) eoan; urgency=medium

  * No-change rebuild for binutils 2.32.51.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 22 Aug 2019 18:23:44 +0200

kcov (36+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #850192)
    - Fix several FTBFS issues
      (Closes: #790912, #839374, #880344, #922698, #787870)
  * Fix insecure-copyright-format-uri
  * Fix wildcard-matches-nothing-in-dep5-copyright
  * Fix unused-license-paragraph-in-dep5-copyright
  * Replace embedded JS libraries with system ones
  * Bump STandards-Version to 4.4.0 (no changes needed)
  * Salvage package (Closes: #931990)

 -- Alessandro Ghedini <ghedo@debian.org>  Fri, 09 Aug 2019 19:51:41 +0100

=== debian/control ===
Source: kcov
Section: devel
Priority: optional
Maintainer: Alessandro Ghedini <ghedo@debian.org>
Build-Depends: debhelper (>= 12),
 binutils-dev,
 cmake,
 libcurl4-openssl-dev,
 libdw-dev,
 libelf-dev,
 libiberty-dev,
 libjs-handlebars,
 libjs-jquery,
 libjs-jquery-tablesorter,
 pkg-config,
 python
Standards-Version: 4.4.0
Vcs-Git: https://salsa.debian.org/debian/kcov.git
Vcs-Browser: https://salsa.debian.org/debian/kcov
Homepage: https://simonkagstrom.github.io/kcov/

Package: kcov
Architecture: any
Depends: python, ${shlibs:Depends}, ${misc:Depends}
Description: Code coverage analysis using DWARF debugging information
 Kcov is a code coverage tester based on bcov by Thomas Neumann. It allows
 collecting code coverage information from executables without special
 command-line arguments, and continuosly produces output from long-running
 applications.
 .
 Kcov, like Bcov, uses DWARF debugging information to make this possible.

## kcov 38%2Bdfsg

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 find_package (CURL)
 
 if (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
-SET (DL_LIBRARY "")
+set (DL_LIBRARY "")
 else (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
 find_library (DL_LIBRARY NAMES dl)
 if (DL_LIBRARY)
@@ -27,7 +27,7 @@
     message (FATAL_ERROR "Could NOT find INTL")
 endif (INTL_LIBRARY)
 else (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
-SET (INTL_LIBRARY "")
+set (INTL_LIBRARY "")
 endif (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
 
 find_library (M_LIBRARY NAMES m)
@@ -109,14 +109,17 @@
 	set (coveralls_SRCS writers/coveralls-writer.cc)
 endif (CURL_FOUND)
 
-if (KCOV_STATIC_BUILD STREQUAL "1")
-	message(STATUS "Building a static binary (no coveralls support)")
+option (KCOV_STATIC_BUILD "Build a static binary" OFF)
+mark_as_advanced (KCOV_STATIC_BUILD)
+
+if (KCOV_STATIC_BUILD)
+	message (STATUS "Building a static binary (no Coveralls support)")
 
 	set (CURL_LIBRARIES "")
 	# Coveralls doesn't work in a static setting
 	set (coveralls_SRCS writers/dummy-coveralls-writer.cc)
 	set (CMAKE_EXE_LINKER_FLAGS "-static")
-endif (KCOV_STATIC_BUILD STREQUAL "1")
+endif (KCOV_STATIC_BUILD)
 
 set (ELF_SRCS
 	dummy-solib-handler.cc
@@ -177,6 +180,9 @@
 		ENV LD_LIBRARY_PATH
 	)
 	mark_as_advanced(LLDB_LIBRARY)
+	if(LLDB_LIBRARY)
+	  message (STATUS "Found LLDB: ${LLDB_LIBRARY}")
+	endif()
 
 	# Not really true, but anyway
 	set(LIBELF_FOUND 1)
@@ -389,14 +395,11 @@
 
 # Reference: http://www.cmake.org/Wiki/CMake_RPATH_handling
 if (SPECIFY_RPATH)
-	set (CMAKE_SKIP_BUILD_RPATH  FALSE)
-	set (CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
-	set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+	set (CMAKE_SKIP_BUILD_RPATH OFF)
+	set (CMAKE_BUILD_WITH_INSTALL_RPATH OFF)
+	set (CMAKE_INSTALL_RPATH_USE_LINK_PATH ON)
 	# the RPATH to be used when installing, but only if it's not a system directory
 	list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" IS_SYSTEM_DIR)
-	if (IS_SYSTEM_DIR STREQUAL "-1")
+	if (IS_SYSTEM_DIR EQUAL -1)
 	    set (CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
-	endif (IS_SYSTEM_DIR STREQUAL "-1")
-endif (SPECIFY_RPATH)
-
-if (LIBELF_FOUND)
+	endif (IS_SYSTEM_DIR EQUAL -1)

## kcov 38+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.4)
project (kcov)

set (PROJECT_VERSION_MAJOR 35)
set (PROJECT_VERSION_MINOR 0)
set (PROJECT_VERSION_PATCH 0)
set (PROJECT_VERSION
     "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

if (POLICY CMP0042)
  # MACOSX_RPATH is enabled by default.
  cmake_policy (SET CMP0042 NEW)
endif (POLICY CMP0042)

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set (CMAKE_BUILD_TYPE Release CACHE STRING
       "Choose the type of build, options are None Debug Release RelWithDebInfo MinSizeRel"
       FORCE)
  set_property (CACHE CMAKE_BUILD_TYPE PROPERTY
                STRINGS None Debug Release RelWithDebInfo MinSizeRel)
endif (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)

add_definitions(-DPACKAGE)
add_definitions(-DPACKAGE_VERSION)
# ====================================
# configuring
# ====================================
list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

option (SPECIFY_RPATH  "Specify RPATH for installed executables" OFF)
mark_as_advanced (SPECIFY_RPATH)

# ====================================
# default install paths for targets
# ====================================
include (CPack.local.cmake OPTIONAL)

set (KCOV_INSTALL_BINDIR "bin" CACHE STRING "Install destination for user executables")
set (KCOV_INSTALL_DOCDIR "share/doc/kcov" CACHE STRING "Install destination for documentation")
set (KCOV_INSTALL_MANDIR "share/man" CACHE STRING "Install destination for man documentation")
mark_as_advanced (KCOV_INSTALL_BINDIR KCOV_INSTALL_DOCDIR KCOV_INSTALL_MANDIR)

install (FILES ChangeLog COPYING COPYING.externals
         DESTINATION "${KCOV_INSTALL_DOCDIR}")

# ====================================
# build all
# ====================================
add_subdirectory (src)
add_subdirectory (doc)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,7 @@
 find_package (ZLIB REQUIRED)
 
 if (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
-SET (DL_LIBRARY "")
+set (DL_LIBRARY "")
 else (CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
 find_library (DL_LIBRARY NAMES dl)
 if (DL_LIBRARY)

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,9 @@
     # MACOSX_RPATH is enabled by default.
     cmake_policy (SET CMP0042 NEW)
 endif (POLICY CMP0042)
+
+option (SPECIFY_RPATH  "Specify RPATH for installed executables" OFF)
+mark_as_advanced (SPECIFY_RPATH)
 
 find_package (LibElf REQUIRED)
 find_package (Elfutils REQUIRED)
@@ -58,14 +61,14 @@
 
 # Reference: http://www.cmake.org/Wiki/CMake_RPATH_handling
 if (SPECIFY_RPATH)
-    set (CMAKE_SKIP_BUILD_RPATH  FALSE)
-    set (CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
-    set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+    set (CMAKE_SKIP_BUILD_RPATH OFF)
+    set (CMAKE_BUILD_WITH_INSTALL_RPATH OFF)
+    set (CMAKE_INSTALL_RPATH_USE_LINK_PATH ON)
     # the RPATH to be used when installing, but only if it's not a system directory
     list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" IS_SYSTEM_DIR)
-    if (IS_SYSTEM_DIR STREQUAL "-1")
+    if (IS_SYSTEM_DIR EQUAL -1)
         set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
-    endif (IS_SYSTEM_DIR STREQUAL "-1")
+    endif (IS_SYSTEM_DIR EQUAL -1)
 endif (SPECIFY_RPATH)
 
 add_executable (${LINE2ADDR} ${${LINE2ADDR}_SRCS})

=== travis/Makefile ===
--- 
+++ 
@@ -48,7 +48,7 @@
 	sudo i386 chroot ${chroot} sh -c "apt-get -y remove binutils-dev"
 	sudo i386 chroot ${chroot} sh -c "mkdir -p /tmp/kcov/build-no-binutils && cd /tmp/kcov/build-no-binutils && cmake .."
 	sudo i386 chroot ${chroot} sh -c "make -C /tmp/kcov/build-no-binutils"
-	sudo i386 chroot ${chroot} sh -c "mkdir -p /tmp/kcov/build-static && cd /tmp/kcov/build-static && cmake -DKCOV_STATIC_BUILD=1 .."
+	sudo i386 chroot ${chroot} sh -c "mkdir -p /tmp/kcov/build-static && cd /tmp/kcov/build-static && cmake -DKCOV_STATIC_BUILD=ON .."
 	sudo i386 chroot ${chroot} sh -c "make -C /tmp/kcov/build-static"
 
 build_clang_linux:

=== tests/unit-tests/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.4)
project (kcov-unit-tests)
list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../cmake")

if (POLICY CMP0042)
    # MACOSX_RPATH is enabled by default.
    cmake_policy (SET CMP0042 NEW)
endif (POLICY CMP0042)

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    set (CMAKE_BUILD_TYPE Debug CACHE STRING
        "Choose the type of build, options are None Debug Release RelWithDebInfo MinSizeRel"
        FORCE
    )
    set_property (CACHE CMAKE_BUILD_TYPE PROPERTY
        STRINGS None Debug Release RelWithDebInfo MinSizeRel
    )
endif (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)

find_package (LibCRPCUT REQUIRED)
find_package (LibElf REQUIRED)
find_package (Elfutils REQUIRED)

set (CMAKE_THREAD_PREFER_PTHREAD ON)
find_package (Threads REQUIRED)

find_package (ZLIB REQUIRED)

find_library (DL_LIBRARY NAMES dl)
if (DL_LIBRARY)
    message (STATUS "Found DL: ${DL_LIBRARY}")
else (DL_LIBRARY)
    message (FATAL_ERROR "Could NOT find DL")
endif (DL_LIBRARY)

set (TGT ut)

set (${TGT}_SRCS
    ../../src/capabilities.cc
    ../../src/collector.cc
    ../../src/engine-factory.cc
    ../../src/engines/system-mode-file-format.cc
    ../../src/gcov.cc
    ../../src/output-handler.cc
    ../../src/parser-manager.cc
    ../../src/source-file-cache.cc
    ../../src/system-mode/registration.cc
    ../../src/system-mode/file-data.cc
    ../../src/utils.cc
    ../../src/writers/cobertura-writer.cc
    ../../src/writers/html-writer.cc
    ../../src/writers/writer-base.cc
    main.cc
    tests-collector.cc
    tests-configuration.cc
    tests-elf.cc
    tests-filter.cc
    tests-reporter.cc
    tests-system-mode.cc
    tests-utils.cc
    tests-writer.cc
)

set (CMAKE_CXX_FLAGS "-std=c++1y -Wall -D_GLIBCXX_USE_NANOSLEEP")


add_custom_command(OUTPUT html-data-files.cc
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/../../src/bin-to-c-source.py"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../data/bcov.css" css_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../../data/amber.png" icon_amber
            "${CMAKE_CURRENT_SOURCE_DIR}/../../data/glass.png" icon_glass
            "${CMAKE_CURRENT_SOURCE_DIR}/../../data/source-file.html" source_file_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../../data/index.html" index_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/handlebars.js" handlebars_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/kcov.js" kcov_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/jquery.min.js" jquery_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/jquery.tablesorter.min.js" tablesorter_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/jquery.tablesorter.widgets.min.js" tablesorter_widgets_text
            "${CMAKE_CURRENT_SOURCE_DIR}/../../data/tablesorter-theme.css" tablesorter_theme_text
       > html-data-files.cc
    DEPENDS
        "${CMAKE_CURRENT_SOURCE_DIR}/../../data/bcov.css"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../data/amber.png"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../data/glass.png"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../data/source-file.html"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../data/index.html"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/handlebars.js"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/kcov.js"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/jquery.min.js"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/jquery.tablesorter.min.js"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/jquery.tablesorter.widgets.min.js"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../data/tablesorter-theme.css"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../src/bin-to-c-source.py"
)

include_directories(
    ../../src/include/
    trompeloeil/include
    ${LIBCRPCUT_INCLUDE_DIRS}
    ${LIBELF_INCLUDE_DIRS}
    ${LIBDW_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
)

add_executable (${TGT} ${${TGT}_SRCS} html-data-files.cc)

target_link_libraries(${TGT}
    ${CMAKE_THREAD_LIBS_INIT}
    "${DL_LIBRARY}"
    ${LIBCRPCUT_LIBRARIES}
    ${LIBDW_LIBRARIES}
    ${LIBELF_LIBRARIES}
    ${ZLIB_LIBRARIES}
)

add_executable (same-name-test
    ../main.cc
    ../subdir/file.c
    ../subdir2/file.c
)

add_executable (test-binary test-source.c second-source.c)
set_target_properties(test-binary PROPERTIES
    COMPILE_FLAGS "-nostdinc"
    LINK_FLAGS "-nostdlib"
)

=== debian/changelog ===
kcov (38+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.5.0 (no changes needed)
  * Build against static binutils libraries (Closes: #949602)

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 09 Feb 2020 12:46:58 +0000

kcov (37+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Exclude external/ directory with LLDB headers from source
  * Refresh patches
  * Bump Standards-Version to 4.4.1 (no changes needed)
  * Replace python (Build-)Depends with python3

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 13 Oct 2019 01:05:35 +0100

=== debian/control ===
--- 
+++ 
@@ -13,15 +13,16 @@
  libjs-jquery,
  libjs-jquery-tablesorter,
  pkg-config,
- python
-Standards-Version: 4.4.0
+ python3
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/debian/kcov.git
 Vcs-Browser: https://salsa.debian.org/debian/kcov
 Homepage: https://simonkagstrom.github.io/kcov/
 
 Package: kcov
 Architecture: any
-Depends: python, ${shlibs:Depends}, ${misc:Depends}
+Built-Using: ${misc:Built-Using}
+Depends: python3, ${shlibs:Depends}, ${misc:Depends}
 Description: Code coverage analysis using DWARF debugging information
  Kcov is a code coverage tester based on bcov by Thomas Neumann. It allows
  collecting code coverage information from executables without special

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

%:
	dh $@


override_dh_gencontrol:
	dh_gencontrol -- -Vmisc:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W binutils-dev)"

=== debian/watch ===
version=3
opts=\
repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s/\+dfsg// \
https://github.com/SimonKagstrom/kcov/tags .*/v(\d.*)\.(?:tgz|tar\.(?:gz|bz2|xz))
